Index: trunk/Poubelle/archTOI.old/Makefile
===================================================================
--- trunk/Poubelle/archTOI.old/Makefile	(revision 358)
+++ trunk/Poubelle/archTOI.old/Makefile	(revision 359)
@@ -1,29 +1,36 @@
 CXX=cxx
 CFITSIODIR=../cfitsio
-CPPFLAGS=-O -I$(CFITSIODIR)
+#CPPFLAGS=-O -I$(CFITSIODIR)
+CPPFLAGS=-g -I$(CFITSIODIR)
 LDLIBS=-L$(CFITSIODIR) -lcfitsio
 archtoi: archtoimain.o archtoi.o archeopsfile.o decompress.o toiiter.o toisvr.o archeops.o \
-         ssthandler.o toiinterpolator.o gpsparser.o
+         ssthandler.o toiinterpolator.o gpsparser.o asigps.o \
+         auxinterpgps.o
 	$(LINK.cc) $^ $(LOADLIBES) $(LDLIBS) -o $@ -lm 
 archdump: archtoidump.o archeopsfile.o decompress.o archeops.o ssthandler.o
 	$(LINK.cc) $^ $(LOADLIBES) $(LDLIBS) -o $@ -lm
 
-archeops.o: archeops.c  archeops.h 
-decompress.o: decompress.c archeops.h  compress.h
+archeops.o: archeops.c archeops_28.c archeops.h archeops_28.h
+decompress.o: decompress.c archeops.h archeops_28.h compress.h
 archeopsfile.o: archeopsfile.cc archeopsfile.h archeops.h \
-  ssthandler.h compress.h
-archtoi.o: archtoi.cc archeopsfile.h archeops.h  \
- ssthandler.h toisvr.h toiiter.h archtoi.h
-archtoidump.o: archtoidump.cc archeopsfile.h archeops.h  \
- ssthandler.h archtoi.h toisvr.h toiiter.h
-archtoimain.o: archtoimain.cc archeopsfile.h archeops.h  \
- ssthandler.h archtoi.h toisvr.h toiiter.h
-ssthandler.o: ssthandler.cc ssthandler.h archeops.h 
-test.o: test.cc archeopsfile.h archeops.h  ssthandler.h \
- archtoi.h toisvr.h toiiter.h
+ archeops_28.h ssthandler.h gpsparser.h compress.h
+archtoi.o: archtoi.cc archeopsfile.h archeops.h archeops_28.h \
+ ssthandler.h gpsparser.h toisvr.h toiiter.h auxgps.h archtoi.h \
+ $(CFITSIODIR)/fitsio.h $(CFITSIODIR)/longnam.h asigps.h auxinterpgps.h
+archtoidump.o: archtoidump.cc archeopsfile.h archeops.h archeops_28.h \
+ ssthandler.h gpsparser.h archtoi.h toisvr.h toiiter.h auxgps.h \
+ $(CFITSIODIR)/fitsio.h $(CFITSIODIR)/longnam.h
+archtoimain.o: archtoimain.cc archeopsfile.h archeops.h archeops_28.h \
+ ssthandler.h gpsparser.h archtoi.h toisvr.h toiiter.h auxgps.h \
+ $(CFITSIODIR)/fitsio.h $(CFITSIODIR)/longnam.h
+asigps.o: asigps.cc asigps.h auxinterpgps.h auxgps.h
+auxinterpgps.o: auxinterpgps.cc auxinterpgps.h auxgps.h \
+ $(CFITSIODIR)/fitsio.h $(CFITSIODIR)/longnam.h archtoi.h toisvr.h toiiter.h \
+ archeopsfile.h archeops.h archeops_28.h ssthandler.h gpsparser.h
+gpsparser.o: gpsparser.cc gpsparser.h archeops.h archeops_28.h
+ssthandler.o: ssthandler.cc ssthandler.h archeops.h archeops_28.h
 toiinterpolator.o: toiinterpolator.cc toiinterpolator.h
 toiiter.o: toiiter.cc toiiter.h archeopsfile.h archeops.h \
-  ssthandler.h toiinterpolator.h
+ archeops_28.h ssthandler.h gpsparser.h auxgps.h toiinterpolator.h
 toisvr.o: toisvr.cc toisvr.h toiiter.h archeopsfile.h archeops.h \
-  ssthandler.h
-gpsparser.o: gpsparser.cc gpsparser.h archeops.h
+ archeops_28.h ssthandler.h gpsparser.h auxgps.h
Index: trunk/Poubelle/archTOI.old/archtoi.h
===================================================================
--- trunk/Poubelle/archTOI.old/archtoi.h	(revision 358)
+++ trunk/Poubelle/archTOI.old/archtoi.h	(revision 359)
@@ -60,5 +60,5 @@
   int fitsStatus;
   int fitsLine;
-  ofstream* ostr;
+  ostream* ostr;
 };
 
Index: trunk/Poubelle/archTOI.old/asigps.cc
===================================================================
--- trunk/Poubelle/archTOI.old/asigps.cc	(revision 358)
+++ trunk/Poubelle/archTOI.old/asigps.cc	(revision 359)
@@ -8,4 +8,5 @@
 void ASIGPS::readFile(string const& filename) {
   ifstream f(filename.c_str());
+  double omjd=0;
   while (f) {
     char line[200];
@@ -47,4 +48,6 @@
     p+=5;
     if (*p != 'm') continue;
+    if (mjd < omjd) continue;
+    omjd = mjd;
     AddValue(mjd, lat, lon, alt);
   }
Index: trunk/Poubelle/archTOI.old/auxinterpgps.cc
===================================================================
--- trunk/Poubelle/archTOI.old/auxinterpgps.cc	(revision 358)
+++ trunk/Poubelle/archTOI.old/auxinterpgps.cc	(revision 359)
@@ -54,8 +54,8 @@
   int fitsLine = 1;
   for (set<elem>::iterator i = elems.begin(); i != elems.end(); i++,fitsLine++) {
-    fits_write_col_dbl(fptr, 1, fitsLine, 1, 1, &(*i).mjd, &fitsStatus);
-    fits_write_col_dbl(fptr, 2, fitsLine, 1, 1, &(*i).lat, &fitsStatus);
-    fits_write_col_dbl(fptr, 3, fitsLine, 1, 1, &(*i).lon, &fitsStatus);
-    fits_write_col_dbl(fptr, 4, fitsLine, 1, 1, &(*i).alt, &fitsStatus);
+    fits_write_col_dbl(fptr, 1, fitsLine, 1, 1, (double*) &(*i).mjd, &fitsStatus);
+    fits_write_col_dbl(fptr, 2, fitsLine, 1, 1, (double*) &(*i).lat, &fitsStatus);
+    fits_write_col_dbl(fptr, 3, fitsLine, 1, 1, (double*) &(*i).lon, &fitsStatus);
+    fits_write_col_dbl(fptr, 4, fitsLine, 1, 1, (double*) &(*i).alt, &fitsStatus);
   }
 